 CBL RENT,APOST,NOMAP,NOSEQ,NODYNAM,LIB,LIST,TEST(ALL,SYM,SEP)    
      * Module/File Name: COBVHPD
      *************************************************
      **                                             **
      ** COBVPHD - HEAP storage corruption sample    **
      ** program to use with CEETRACE and the        **
      ** "env_validation" option support.            **
      **                                             **
      ** Execute this sample with CEETRACE active,   **
      ** in a CEETRACE enabled (or not excluded)     **
      ** partition with env_validation=off and then  **
      ** again with env_validation=heap set.         **
      **                                             **
      ** See the included CEETRACE Installation and  **
      ** Users Guide for details on how to activate, **
      ** compile CEETRACE-enabled applications and   **
      ** how to set CEETRACE options.                **
      **                                             **
      ** See below for more details on this sample   **
      ** program.                                    ** 
      **                                             **
      *************************************************
              
       IDENTIFICATION DIVISION.                                                 
       PROGRAM-ID.    COBVHPD.                                                  
       ENVIRONMENT DIVISION.                                                    
       CONFIGURATION SECTION.                                                   
       INPUT-OUTPUT SECTION.                                                    
       FILE-CONTROL.                                                            
       DATA  DIVISION.                                                          
       WORKING-STORAGE SECTION.                                                 
       01 WS-EYE-STRT      PIC X(4) VALUE 'WS-B'.                               
       01 HEAPID           PIC S9(9) BINARY VALUE 0.                            
       01 STORAGE-SIZE-12  PIC S9(9) BINARY VALUE 12.                           
       01 STORAGE-SIZE-16  PIC S9(9) BINARY VALUE 16.                           
       01 ADDRESS-1        POINTER.                                             
       01 ADDRESS-2        POINTER.                                             
       01 ADDRESS-3        POINTER.                                             
       01 WS-DATA.                                                              
           03 WS-DATA1     PIC X(16) VALUE '1234567890123456'.                  
           03 WS-DATA2     PIC S9(4) BINARY VALUE 4369.                         
       01  INTEGER         PIC S9(9) BINARY.                                    
       01  FC.                                                                  
           02  Condition-Token-Value.                                           
           COPY  CEEIGZCT.                                                      
              03  Case-1-condition-ID.                                          
                 04  Severity   PIC S9(4) BINARY.                               
                 04  Msg-No     PIC S9(4) BINARY.                               
              03  Case-2-condition-ID                                           
                   REDEFINES Case-1-condition-ID.                               
                 04  Class-Code PIC S9(4) BINARY.                               
                 04  Cause-Code PIC S9(4) BINARY.                               
              03  Case-Sev-Ctl  PIC X.                                          
              03  Facility-ID   PIC XXX.                                        
           02  I-S-Info         PIC S9(9) BINARY.                               
       01 WS-EYE-END       PIC X(4) VALUE 'WS-E'.                               
                                                                                
       LINKAGE SECTION.                                                         
       01  HEAP-DATA-AREA       PIC X(18).                                      
       PROCEDURE DIVISION.                                                      
***** *                                                                         
***** * Simple COBOL program to produce a HEAP overlay and test                 
***** * resulting behaviour.                                                    
***** *                                                                         
           DISPLAY 'COBVHPD - BEGINS.' UPON CONSOLE.                            
***** *                                                                         
           PERFORM 0200-HEAPOVL Thru 0200-Exit.                                 
***** *                                                                         
           Display ' Test case now complete.'.                                  
           DISPLAY 'COBVHPD - COMPLETE' UPON CONSOLE.                           
           GOBACK.                                                              
***** *                                                                         
       0200-HEAPOVL.                                                            
           Display ' Acquire 3 HEAP elements to work with'.                     
           CALL 'CEEGTST' USING HEAPID, STORAGE-SIZE-16, ADDRESS-1, FC.         
           CALL 'CEEGTST' USING HEAPID, STORAGE-SIZE-16, ADDRESS-2, FC.         
           CALL 'CEEGTST' USING HEAPID, STORAGE-SIZE-16, ADDRESS-3, FC.         
***** *                                                                         
***** * Create an element on the "free" tree by freeing one of the              
***** * above allocated elements.                                               
***** *                                                                         
           Display ' Free one element to create a free tree entry'.             
           CALL 'CEEFRST' USING ADDRESS-2, FC.                                  
***** *                                                                         
***** * Overlay two bytes of the control information for the heap               
***** * free tree which is following our last allocate heap at                  
***** * ADDRESS-3.                                                              
***** *                                                                         
           Display ' Overlay the first two bytes of the free entry'.            
           SET ADDRESS OF HEAP-DATA-AREA TO ADDRESS-3.                          
           MOVE WS-DATA TO HEAP-DATA-AREA.                                      
***** *                                                                         
***** * The above MOVE statement will cause an overlay of the HEAP              
***** * free element control information stored after the last HEAP             
***** * element allocated.                                                      
***** *                                                                         
***** * We will now request a HEAP element of a size that will                  
***** * fit within the freed area causing LE to check the HEAP                  
***** * "free-tree" control information.                                        
***** *                                                                         
           Display ' Get another HEAP element to force a HEAP check.'.          
*****      CALL 'CEEGTST' USING HEAPID, STORAGE-SIZE-12, ADDRESS-2, FC.         
           Display ' Paragraph 0200-HEAPOVL completed.'.                        
                                                                                
       0200-EXIT.                                                               
           EXIT.                                                                
